Subject: Re: bug#20727: 24.5; Font fallback doesn't work for the Emoji range

From: Eli Zaretskii <[email-masked]>
Date: Sun, 14 Jun 2015 20:37:44 +0300

> Date: Sun, 14 Jun 2015 09:14:27 -0700
> From: Paul Eggert <[email-masked]>
> CC: [email-masked], [email-masked], 
>  [email-masked]
> 
> I'm not sure, but I found that my ~/.emacs file, at the end, said 
> "(custom-set-faces)" -- something I didn't put in there, but I suppose I ran 
> "customize" at some point in the unremembered past, though I don't remember ever 
> customizing fonts.  I suppose the settings installed by custom-set-faces, 
> whatever they are, alter the fonts installed by the recent change, and this 
> messes up my testing.  (Possibly they saved faces calculated *before* the recent 
> change to Emacs, and custom-set-faces is trying to restore them?)  I will 
> comment out the customization code before doing further testing, but these are 
> the sorts of glitches that I fear will affect other users.

We will have to wait and see, I guess.  I hope the problems will not
be acute, mostly when someone already have fontset customizations, and
therefore can adapt.

> U+201F DOUBLE HIGH-REVERSED-9 QUOTATION MARK now displays as 
> xft:-unknown-Symbola-normal-normal-semicondensed-*-17-*-*-*-*-0-iso10646-1 
> (#x39B) which is spidery, whereas it formerly displayed as 
> xft:-unknown-FreeMono-normal-normal-normal-*-17-*-*-*-m-0-iso10646-1 (#x8A8) 
> which is more legible.
> 
> U+204F REVERSED SEMICOLON has a similar problem.
> 
> U+2047 DOUBLE QUESTION MARK
> U+2048 QUESTION EXCLAMATION MARK
> U+2049 EXCLAMATION QUESTION MARK
> are too large in Symbola; the old FreeMono version was better.

These are all in the General Punctuation block.  FreeMono covers only
about one third of the block (40 characters out of 111); Symbola
covers all of them.  It's a simple change to prefer FreeMono for those
characters that it supports (after all, FreeMono is a GNU font), but
won't that have adverse effect if some other punctuation characters,
unsupported by FreeMono, will have to be displayed?  You can try
something like

  (set-fontset-font "fontset-default" '(#x2047 . #x204B) "FreeMono")

and then try typing characters from this range and also a few outside
of it, but still between 2000..206F -- is the result acceptable?  It
looks weird on my system, but I think I'm less sensitive to these
issues, so I'm not sure about others.

> The currency symbols look worse than before: they used to be constant-width 
> (most of them anyway) and matched Ubuntu Mono better.  Perhaps we should leave 
> them alone?

Which font did they use before?

In general, most fonts support only a handful of characters in the
Currency Symbol block.  I left only the Euro sign, which is almost
universally supported, out of Symbola coverage.  I could add a few
more to the exempted codepoints, or indeed leave out the entire block,
but then we could risk boxes with hex code with some fonts.

> Thanks for doing all this -- it must have taken you quite some time.

You're welcome.  Yes, that's a lot of mundane work, but someone needs
to do it.